using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace TorresDeHanoi
{
    public partial class Form1 : Form
    {
        int MaximoDeDiscos = 9;
        System.Windows.Forms.Label[] aneis;// = new Label[MaximoDeDiscos];
        System.Windows.Forms.Label[] mover = new Label[3];
        int[] topo = new int[3];
        int[,] configuracaoAtual;// = new int[3, MaximoDeDiscos];
        int[] mastros = new int[3];
        long numeroDeOperacoesRealizadas;
        int atraso;
        Color corPadrao;

        public Form1()
        {
            InitializeComponent();
            corPadrao = btn0.BackColor;
            aneis = new Label[MaximoDeDiscos];
            configuracaoAtual = new int[3, MaximoDeDiscos];
            mastros[0] = label1.Location.X + label1.Width / 2;
            mastros[1] = label2.Location.X + label2.Width / 2;
            mastros[2] = label3.Location.X + label3.Width / 2;
            aneis[0] = an0;
            aneis[1] = an1;
            aneis[2] = an2;
            aneis[3] = an3;
            aneis[4] = an4;
            aneis[5] = an5;
            aneis[6] = an6;
            aneis[7] = an7;
            aneis[8] = an8;
            mover[0] = move01;
            mover[1] = move02;
            mover[2] = move12;
            int necessarias = (int)Math.Pow(2, MaximoDeDiscos) - 1;
            lblNecessarias.Text = necessarias.ToString();
            inicializarDados(MaximoDeDiscos);
        }

        private void cmdExecutar_Click(object sender, EventArgs e)
        {
            int numeroDeDiscos = 5;
            try { numeroDeDiscos = int.Parse(txtDiscos.Text); }
            catch { numeroDeDiscos = 5; }
            if (numeroDeDiscos == 0 || numeroDeDiscos > MaximoDeDiscos) numeroDeDiscos = MaximoDeDiscos;
            inicializarDados(numeroDeDiscos);

            this.Refresh();            
            System.Threading.Thread.Sleep(atraso);
            // Executar mudana:
            move(0, 2, 1, numeroDeDiscos);

            //aneis[3] = an3;
        }

        void inicializarDados(int numeroTotalDeDiscos)
        {
            try
            {
                atraso = int.Parse(txtAtraso.Text);
            }
            catch
            {
                atraso = 1000;
            }

            numeroDeOperacoesRealizadas = 0;
            lblNumOperacoes.Text = "0";
            topo[0] = numeroTotalDeDiscos;
            topo[1] = 0;
            topo[2] = 0;



            for (int i = 0; i < numeroTotalDeDiscos; i++)
            {
                aneis[i].Location = new Point(mastros[0] - aneis[i].Width / 2, 295-i*16);
                configuracaoAtual[0, i] = i;
                aneis[i].Visible = true;
            }

            for (int i = numeroTotalDeDiscos; i < MaximoDeDiscos; i++)
            {
                aneis[i].Visible = false;
            }

        }

        void move(int origem, int destino, int auxiliar, int nDiscos)
        {

            if (nDiscos == 1) {
                efetuarMovimentoPropriamenteDito(origem,destino,auxiliar);
		    }
		    else {
			    move(origem, auxiliar, destino, nDiscos - 1);
			    move(origem, destino, auxiliar, 1);
			    move(auxiliar, destino, origem, nDiscos - 1);
		    }
        }

        private bool efetuarMovimentoPropriamenteDito(int origem, int destino, int auxiliar)
        {
            if (topo[origem] == 0) return false;
            int anelDeOrigem = configuracaoAtual[origem, topo[origem]-1];
            int anelTopoDestino = 999999;
            if (topo[destino] > 0)
            {
                anelTopoDestino = configuracaoAtual[destino, topo[destino] - 1];
                if (anelTopoDestino > anelDeOrigem) return false;
            }

            topo[origem]--;

            int movimentoAtual = 2;
            bool esquerdaParaDireita = true;
            if (origem == 0 || destino == 0)
            {
                if (origem == 1 || destino == 1) movimentoAtual = 0;
                else movimentoAtual = 1;
            }

            if (origem > destino) esquerdaParaDireita = false;
            if (esquerdaParaDireita) mover[movimentoAtual].Text = "=>";
            else mover[movimentoAtual].Text = "<=";
            mover[movimentoAtual].ForeColor = aneis[anelDeOrigem].BackColor;
            mover[movimentoAtual].Visible = true;
            System.Threading.Thread.Sleep(atraso / 10);


            int xDestino = aneis[anelDeOrigem].Location.X + (destino - origem) * 250;
            int yDestino = 295 - 16 * topo[destino];
            aneis[anelDeOrigem].Location = new Point(xDestino, yDestino);


            numeroDeOperacoesRealizadas++;
            lblNumOperacoes.Text = numeroDeOperacoesRealizadas.ToString();
            configuracaoAtual[destino, topo[destino]] = anelDeOrigem;
            topo[destino]++;

            this.Refresh();
            System.Threading.Thread.Sleep(atraso);
            mover[movimentoAtual].Visible = false;

            return true;
        }

        private void txtDiscos_TextChanged(object sender, EventArgs e)
        {
            int numeroDeDiscos = 5;
            try { numeroDeDiscos = int.Parse(txtDiscos.Text); }
            catch { numeroDeDiscos = 5; }
            if (numeroDeDiscos == 0 || numeroDeDiscos > MaximoDeDiscos) numeroDeDiscos = MaximoDeDiscos;
            inicializarDados(numeroDeDiscos);
            txtDiscos.Text = numeroDeDiscos.ToString();
            txtDiscos.SelectAll();
            int necessarias = (int)Math.Pow(2,numeroDeDiscos) - 1;
            lblNecessarias.Text = necessarias.ToString();
            this.Refresh();
        }

        private void txtDiscos_Click(object sender, EventArgs e)
        {
            txtDiscos.SelectAll();
        }

        private void clicarBotao(Button but){
            btn0.Text = "Mover para ca";
            btn1.Text = "Mover para ca";
            btn2.Text = "Mover para ca";
            but.FlatStyle = FlatStyle.Flat;
            but.BackColor = Color.Gold;
            but.Text = "Mover a partir daqui";
        }

        private void reinicarBotoes(){
            btn0.Text = "Mover a partir daqui";
            btn1.Text = "Mover a partir daqui";
            btn2.Text = "Mover a partir daqui";
            btn0.FlatStyle = FlatStyle.Standard;
            btn1.FlatStyle = FlatStyle.Standard;
            btn2.FlatStyle = FlatStyle.Standard;
            btn0.BackColor = corPadrao;
            btn1.BackColor = corPadrao;
            btn2.BackColor = corPadrao;
        }

        private void btn0_Click(object sender, EventArgs e)
        {
            if (btn0.FlatStyle == FlatStyle.Standard)
            {
                if (btn1.FlatStyle == FlatStyle.Standard && btn2.FlatStyle == FlatStyle.Standard) clicarBotao(btn0);
                else
                {
                    if (btn1.FlatStyle == FlatStyle.Flat) { if (!efetuarMovimentoPropriamenteDito(1, 0, 2)) MessageBox.Show("Movimento Irregular"); }
                    else if (!efetuarMovimentoPropriamenteDito(2, 0, 1)) MessageBox.Show("Movimento Irregular");
                    reinicarBotoes();
                }
            }
            else { reinicarBotoes(); }
        }

        private void btn1_Click(object sender, EventArgs e)
        {
            if (btn1.FlatStyle == FlatStyle.Standard)
            {
                if (btn0.FlatStyle == FlatStyle.Standard && btn2.FlatStyle == FlatStyle.Standard) clicarBotao(btn1);
                else
                {
                    if (btn0.FlatStyle == FlatStyle.Flat) { if (!efetuarMovimentoPropriamenteDito(0, 1, 2)) MessageBox.Show("Movimento Irregular"); }
                    else if (!efetuarMovimentoPropriamenteDito(2, 1, 0)) MessageBox.Show("Movimento Irregular");
                    reinicarBotoes();
                }
            }
            else { reinicarBotoes(); }
        }

        private void btn2_Click(object sender, EventArgs e)
        {
            if (btn2.FlatStyle == FlatStyle.Standard)
            {
                if (btn0.FlatStyle == FlatStyle.Standard && btn1.FlatStyle == FlatStyle.Standard) clicarBotao(btn2);
                else
                {
                    if (btn0.FlatStyle == FlatStyle.Flat) { if (!efetuarMovimentoPropriamenteDito(0, 2, 1)) MessageBox.Show("Movimento Irregular"); }
                    else if (!efetuarMovimentoPropriamenteDito(1, 2, 0)) MessageBox.Show("Movimento Irregular");
                    reinicarBotoes();
                }
            }
            else { reinicarBotoes(); }
            if (topo[2] == int.Parse(txtDiscos.Text))
            {
                if (int.Parse(lblNecessarias.Text) == int.Parse(lblNumOperacoes.Text)){
                    MessageBox.Show("Torres de Hanoi resolvidas com numero minimo de operacoes.", "Parabens!");
                }else MessageBox.Show("Torres de Hanoi resolvidas corretamente.");
            }
        }

        private void btnReiniciar_Click(object sender, EventArgs e)
        {
            inicializarDados(int.Parse(txtDiscos.Text));
        }

    }

}
